/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
** 
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <stdio.h>
#include <qstring.h> 
#include <qmessagebox.h>  
#include "MainForm.h" 
#include "Debuger_Project.h"
#include <qfont.h> 
#include <qcolor.h>
#include <qwidget.h>
#include <qrect.h>
#include <qfile.h> 
#include <qtextedit.h>
#include <qcolor.h>
#include <qprocess.h>
#include <qregexp.h>
#include <qlistview.h>
void Debuger_Form::init()
{
    variable_list->setSorting(-1, false);
    Cmd_Next_Step->setDisabled(true);
    Cmd_Next_Break->setDisabled(true);
    Cmd_No_Break->setDisabled(true);
    Terminal->installEventFilter(this);

    Value_Text->hide();
    Gloval__Value_list->hide();
    Break_index = 0; 
    pText[0] = text;
    Text_index = 0;
    data_buffer->hide();
    snprintf_code1->hide();
    snprintf_code2->hide();
    snprintf_code3->hide();
    snprintf_code4->hide();
    Terminal->setEnabled(false);
    this->showMaximized();
    V_R_Table->setColumnWidth(0, 120);
    V_R_Table->setColumnWidth(1,120);
    text->installEventFilter(this);
}



void Debuger_Form::Set_MainForm_Pointer( MainForm *fp )
{
    mainform = fp;
}

 
void Debuger_Form::Add_Debuger_Tab(QString PageLabel)
{
////////////////////////////////////// Variables  ///////// ////////////////////////////////////////////////////
    QWidget *pTabPage = NULL;
    QRect Tab_rect = Debuger_Tab->rect();//Get the tab Size( rect )
    QRect Text_rect(Tab_rect.left()+5, Tab_rect.top() +5 , Tab_rect.right() -13, Tab_rect.bottom() -43);//Set TextEidt Rect
    QString Open_Path;
    Open_Path.sprintf("%s%s", mainform->Path.ascii(), PageLabel.ascii());
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    if(Debuger_Tab->label(0) == "None")// if the SourceFile is added at first..( TabPage is added at first)
    {
	if(!Load_File(Open_Path))
	{
	    FILE *fp;
	    fp = fopen(Open_Path.ascii(), "w");
	    fclose(fp);	    
	}
	pText[Text_index]->show(); // Show the Hided TextEdit 
	pText[Text_index]->setGeometry(Text_rect); // Set Geometry Using Text Rect
	Debuger_Tab->changeTab(Debuger_Tab->currentPage(), PageLabel); // Change TabPage Label( Source File name ).
	Text_index++;
    }
    else
    {
	pTabPage = new QWidget(this->Debuger_Tab); // Creat new Widget of TabPage
	pText[Text_index] = new QTextEdit(pTabPage); // Store the Pointer of  TextEdit
	
	if(!Load_File(Open_Path))
	{
	    FILE *fp;
	    fp = fopen(Open_Path.ascii(), "w");
	    fclose(fp); 
	}
	this->Debuger_Tab->addTab( pTabPage , PageLabel ); // Add the TabPage
	pText[Text_index]->setGeometry(Text_rect); //  Set Geometry the TextEdit
	connect(pText[Text_index] , SIGNAL(cursorPositionChanged(int, int)), this , SLOT(Debuger_code_text_chaged()));
	pText[Text_index]->setWordWrap(QTextEdit::NoWrap);
	pText[Text_index]->installEventFilter(this);
	Text_index++;
    }
}


int Debuger_Form::Load_File( QString filename )
{
    QFile file;
    QColor color(100, 11, 40);
    if(!filename.isEmpty())
    {
	  file.setName(filename);
	  if(!file.open(IO_ReadOnly))
	  {
	      QMessageBox::warning(this, "File ("+ filename +") Open Error", "Can NOT open File ( "+ filename +" )\nSo Load Empty File on this FileName");
	      return false;
	 }
	 
	 QTextStream stream(&file);
	 pText[Text_index]->setText(stream.read());
	 file.close();
	 return true;	 
     }
    return false;
}
 

void Debuger_Form::Set_File_List()
{
    char path[500];
    memset(&path, 0, sizeof(path));
    strcat(path, mainform->Path.ascii());
    strcat(path, mainform->ProName.ascii());
    Debuger_Project debuger(this);
    debuger.Load_Project(path);
}

void Debuger_Form::Cmd_SetBreakPoint_Clicked()
{
    QColor color(255, 155, 155);
    QString break_line;
    int line, col;
    pText[Debuger_Tab->indexOf(Debuger_Tab->currentPage())]->getCursorPosition(&line, &col);
    break_line = Make_Break_Code(Debuger_Tab->indexOf(Debuger_Tab->currentPage()), line);
    if( Check_Break_Point( atoi(break_line.ascii())))//Check Break Line
    {
	Break_list[Break_index++] = atoi(break_line.ascii());
	pText[Debuger_Tab->indexOf(Debuger_Tab->currentPage())]->setParagraphBackgroundColor(line, color);
    }
}


QString Debuger_Form::Make_Break_Code( int tab_page, int line )
{
    QString break_line;
    if( tab_page < 10 )
    {
	if( line < 10)
	    break_line.sprintf("0%d000%d",tab_page, line);
	else if( line < 100 )
	    break_line.sprintf("0%d00%d", tab_page, line);
	else if ( line < 1000 )
	    break_line.sprintf("0%d0%d", tab_page, line);
	else
	    break_line.sprintf("0%d%d", tab_page, line);
    }
    else
    {
	if( line < 10)
	    break_line.sprintf("%d000%d", tab_page, line);
	else if( line < 100 )
	    break_line.sprintf("%d00%d", tab_page, line);
	else if ( line < 1000 )
	    break_line.sprintf("%d0%d", tab_page, line);
	else
	    break_line.sprintf("%d%d", tab_page, line);
    }
    return break_line;
}


bool Debuger_Form::Check_Break_Point( int line )// For Checking Break Line
{
    for(int i = 0 ; i < Break_index ; i++)
    {
	if(Break_list[i] == line)
	    return false;
    }
    return true;
}

void Debuger_Form::Cmd_Next_Break_clicked()
{
    QColor color(255,155, 155);
    QColor step_color(155, 155,255);
    char Working_line[10];
    char debuger_page[3];
    bool flag = false;
    QString temp;
    QFont Font( "Sans Serif", 11, QFont::Bold );    
    memset(&Working_line, 0, sizeof(Working_line));
    write(fd[1], "110", 13);
    read(fd_p[0], Working_line, 10);
    if( Working_line[0] == '/')
    {
	Cmd_Next_Step->setEnabled(false);
	Cmd_Next_Break->setEnabled(false);
	ExcutionTerminal->setFont(Font);
	temp.sprintf("%s", Working_line + 1);
	memset(&Working_line, 0, sizeof(Working_line));
	strcpy(Working_line, temp.ascii());
    }
    else if( Working_line[0] == '@' )
    {
	temp.sprintf("%s", Working_line + 1);
	memset(&Working_line, 0, sizeof(Working_line));
	strcpy(Working_line, temp.ascii());
	flag = true;	
	
    }
    if( atoi(Working_line) < 10 )
	temp.sprintf("00000%d", atoi(Working_line));
    else if( atoi(Working_line) < 100 )
	temp.sprintf("0000%d", atoi(Working_line));
    else if( atoi(Working_line) < 1000 )
	temp.sprintf("000%d", atoi(Working_line));
    else if( atoi(Working_line) < 10000 )
	temp.sprintf("00%d", atoi(Working_line));
    else if( atoi(Working_line) < 100000 )
	temp.sprintf("0%d", atoi(Working_line));
    else
	temp.sprintf("%d", atoi(Working_line));
    strcpy( Working_line, temp.ascii());
    strncpy(debuger_page, Working_line, 2);
    Debuger_Tab->showPage(Debuger_Tab->page(atoi(debuger_page)));
    
    if( atoi(Working_line + 2) != Debuging_line[atoi(debuger_page)] )//Setting Working LIne
    {
	if( pText[atoi(debuger_page) ]->paragraphBackgroundColor( Debuging_line[atoi(debuger_page)] ) != color )
	    pText[atoi(debuger_page)]->setParagraphBackgroundColor( Debuging_line[atoi(debuger_page)], Qt::white );
	Debuging_line[atoi(debuger_page)] = atoi(Working_line + 2);
	if( pText[atoi(debuger_page) ]->paragraphBackgroundColor( atoi(Working_line + 2) ) != color )
	    pText[atoi(debuger_page)]->setParagraphBackgroundColor( atoi(Working_line + 2) , step_color );
    }
    pText[atoi(debuger_page)]->setCursorPosition( atoi(Working_line + 2) , 0);
	if( flag)
	{
	    int table_index;
	    Set_Variable_list();	    
	    Set_Gloval_Variable_list();	    
	    table_index = V_R_Table->currentRow();
	    for( int i = 0 ; i < 64 ; i++)
	    {
		if( V_R_Table->text(i, 0).isEmpty() == false)
		{
		    V_R_Table->setCurrentCell( i, 0 );
		    Cmd_Value_INFO_clicked();
		}
	    }
	    V_R_Table->setCurrentCell(table_index, 0 );
	}

}


void Debuger_Form::Cmd_Next_Step_clicked()
{
    QColor color(255, 155, 155);
    QColor step_color(155, 155,255);
    char Working_line[10];
    char debuger_page[3];
    QString temp;
    bool flag =false;
    QFont Font( "Sans Serif", 11, QFont::Bold );
    memset(&Working_line, 0, sizeof(Working_line));
    write(fd[1], "111", 13);
    read(fd_p[0], Working_line, 10);
    if( Working_line[0] == '/')
    {
	Cmd_Next_Step->setEnabled(false);
	Cmd_Next_Break->setEnabled(false);
	ExcutionTerminal->setFont(Font);
	temp.sprintf("%s", Working_line + 1);
	memset(&Working_line, 0, sizeof(Working_line));
	strcpy(Working_line, temp.ascii());
    }
    else if( Working_line[0] == '@' )
    {
	temp.sprintf("%s", Working_line + 1);
	memset(&Working_line, 0, sizeof(Working_line));
	strcpy(Working_line, temp.ascii());
	flag = true;	
	
    }
    if( atoi(Working_line) < 10 )
	temp.sprintf("00000%d", atoi(Working_line));
    else if( atoi(Working_line) < 100 )
	temp.sprintf("0000%d", atoi(Working_line));
    else if( atoi(Working_line) < 1000 )
	temp.sprintf("000%d", atoi(Working_line));
    else if( atoi(Working_line) < 10000 )
	temp.sprintf("00%d", atoi(Working_line));
    else if( atoi(Working_line) < 100000 )
	temp.sprintf("0%d", atoi(Working_line));
    else
	temp.sprintf("%d", atoi(Working_line)); 
    strcpy( Working_line, temp.ascii());
    strncpy(debuger_page, Working_line, 2);
    Debuger_Tab->showPage(Debuger_Tab->page(atoi(debuger_page)));
    
    if( atoi(Working_line + 2) != Debuging_line[atoi(debuger_page)] )//Setting Working LIne
    {
	if( pText[atoi(debuger_page) ]->paragraphBackgroundColor( Debuging_line[atoi(debuger_page)] ) != color )
	{
	    pText[atoi(debuger_page)]->setParagraphBackgroundColor( Debuging_line[atoi(debuger_page)], Qt::white );
	}
	Debuging_line[atoi(debuger_page)] = atoi(Working_line + 2); 
	if( pText[atoi(debuger_page) ]->paragraphBackgroundColor( atoi(Working_line + 2) ) != color )
	{
	    pText[atoi(debuger_page)]->setParagraphBackgroundColor( atoi(Working_line + 2) , step_color );
	}
    }
        pText[atoi(debuger_page)]->setCursorPosition( atoi(Working_line + 2) , 0);
	if( flag)
	{
	    int table_index;
    	    Set_Variable_list();
	    Set_Gloval_Variable_list();
	    table_index = V_R_Table->currentRow();
	    for( int i = 0 ; i < 64 ; i++)
	    {
		if( V_R_Table->text(i, 0).isEmpty() == false)
		{
		    V_R_Table->setCurrentCell( i, 0 );
		    Cmd_Value_INFO_clicked();
		}
	    }
	    V_R_Table->setCurrentCell(table_index, 0 );
	}
}

void Debuger_Form::Cmd_NO_Break_clicked()
{
    write(fd[1], "101", 13);
    write(fd[1], "101", 13);
    write(fd[1], "101", 13);
    write(fd[1], "101", 13);
}


void Debuger_Form::Cmd_Value_INFO_clicked()
{
    if(Find_Value_INFO( Value_Text ) == false)
	Find_Value_INFO( Gloval__Value_list );
}

bool Debuger_Form::Find_Value_INFO( QTextEdit *value_text )
{
    QString temp;
    temp = V_R_Table->text( V_R_Table->currentRow(), V_R_Table->currentColumn());
    if( V_R_Table->currentColumn() == 1 || temp.isEmpty() || Cmd_Next_Step->isEnabled() == false)
	return false ;
////////////////////// V_R_Table Array Check////////////////////////////////////////////////    
    int temp_index = 0;
    bool address_check = false;
    bool pointer_flag = false;
    bool array_check = false;
    bool check_end = false;
    char array_temp1[100];
    char array_temp2[100];
    char VR_array_num[20];
    memset(&array_temp1, 0, sizeof(array_temp1));
    memset(&array_temp2, 0, sizeof(array_temp2));
    memset(&VR_array_num, 0, sizeof(VR_array_num));    
    strcpy(array_temp1, temp.ascii());
    for( int k = 0 ; k <strlen(array_temp1) ; k++)
    {
	if(array_temp1[k] == ' ' || array_temp1[k] == '	' )
	{
	}
	else if( array_temp1[k] == '[' )
	{
	    array_check = true;
	    temp_index = 0;
	}
	else if(array_temp1[k] == ']')
	{
	    check_end = true;
	    
	}
	else if( array_temp1[k] == '&')
	{
	    address_check = true;
	}
	else if( array_temp1[k] == '*')
	{
	    pointer_flag = true;	    
	}
	else
	{
	    if(array_check == false)
		array_temp2[temp_index] = array_temp1[k];	    
	    else if( array_check == true && check_end == true)
	    {
		  if( value_text == Gloval__Value_list)
		    V_R_Table->setText(V_R_Table->currentRow(), 1, "This is not Value in this program!!");
		    return false;		
	    }
	    else
	    {
		VR_array_num[temp_index] = array_temp1[k];
	    }
	    temp_index++;
	}
    }
    temp.sprintf("%s", array_temp2);
//////////////////////////////////////////////////////////////////////////////////////////////    
    QString Value_INFO[3];
    int array_byte;
    int index = 0;
    int array_size;
    char buffer[100];
    char Value_code[300];
    char Send_message[300];
    bool char_flag = false; // for Checking char array ------------>  %c OR %s
    memset(&Send_message, 0, sizeof(Send_message));    
    for(int i = value_text->paragraphs() -1; i > -1 ; i--)
    {
	index = 0;
	memset(&Value_code, 0, sizeof(Value_code));
	memset(&buffer, 0, sizeof(buffer));
	strcpy(Value_code, value_text->text(i).ascii());
	memset(&Send_message, 0, sizeof(Send_message)); 
	if( pointer_flag == true)
	{
	    strcat(Send_message, "*");
	}
	for(int j = 0 ; j < strlen(Value_code) ; j++)
	{
	    if( Value_code[j] == '/' )
	    {
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		if( index == 0)
		{
		    strncpy(buffer, Value_code, j);
		    Value_INFO[0].sprintf("%s", buffer);
		    if( strcmp( buffer , "int") == 0)
		    {
			strcat(Send_message, "00000");
			index = 1;
		    }	
		    else if( strcmp( buffer , "char") == 0)
		    {
			strcat(Send_message, "00001");			
			index = 1;			
		    }
		    else if( strcmp( buffer , "short") == 0)
		    {
			strcat(Send_message, "00002");
			index = 1;			
		    }
		    else if( strcmp( buffer , "float") == 0)
		    {
			strcat(Send_message, "00003");
			index = 1;			
		    }
		    else if( strcmp( buffer , "double") == 0)
		    {
			strcat(Send_message, "00004");
			index = 1;			
		    }
		    else if( strcmp( buffer , "bool") == 0)
		    {
			strcat(Send_message, "00005");
			index = 1;			
		    }
		    else if( strcmp( buffer , "long") == 0)
		    {
			strcat(Send_message, "00006");
			index = 1;			
		    }
		    if( strcmp( buffer , "^int" ) == 0&& array_check)
		    {
			strcat(Send_message, "00007");
			array_byte = 4;
			index = 3;
		    }	
		    else if( strcmp( buffer , "^char" ) == 0&& array_check)
		    {
			strcat(Send_message, "00008" );	
			array_byte = 1;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^short") == 0 && array_check)
		    {
			strcat(Send_message, "00009");
			array_byte = 2;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^float") == 0 && array_check)
		    {
			strcat(Send_message, "00010");
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^double") == 0 && array_check)
		    {
			strcat(Send_message, "00011");
			array_byte = 8;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^bool") == 0 && array_check)
		    {
			strcat(Send_message, "00012");
			array_byte = 1;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^long") == 0 && array_check)
		    {
			strcat(Send_message, "00013");
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^char" ) == 0&& array_check == false)
		    {
			strcat(Send_message, "00014" );			
			char_flag = true;
			index = 3;			
		    }
		    else if( strcmp( buffer , "*int") == 0)
		    {
			strcat(Send_message, "00015");
			index = 1;
		    }	
		    else if( strcmp( buffer , "*char") == 0)
		    {
			strcat(Send_message, "00016");			
			index = 1;			
		    }
		    else if( strcmp( buffer , "*short") == 0)
		    {
			strcat(Send_message, "00017");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*float") == 0)
		    {
			strcat(Send_message, "00018");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*double") == 0)
		    {
			strcat(Send_message, "00019");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*bool") == 0)
		    {
			strcat(Send_message, "00020");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*long") == 0)
		    {
			strcat(Send_message, "00021");
			index = 1;			
		    }
		    if( strcmp( buffer , "^*int" ) == 0&& array_check)
		    {
			strcat(Send_message, "00022");
			array_byte = 4;
			index = 3;
		    }	
		    else if( strcmp( buffer , "^*char" ) == 0&& array_check)
		    {
			strcat(Send_message, "00023" );	
			array_byte = 1;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*short") == 0 && array_check)
		    {
			strcat(Send_message, "00024");
			array_byte = 2;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*float") == 0 && array_check)
		    {
			strcat(Send_message, "00025");
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*double") == 0 && array_check)
		    {
			strcat(Send_message, "00026");
			array_byte = 8;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*bool") == 0 && array_check)
		    {
			strcat(Send_message, "00027");
			array_byte = 1;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*long") == 0 && array_check)
		    {
			strcat(Send_message, "00028");
			array_byte = 8;
			index = 3;			
		    }
		    memset(&buffer, 0, sizeof(buffer));

		}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
		else if( index == 1 )
		{
		    strncpy(buffer, Value_code + Value_INFO[0].length() + 1, j - (Value_INFO[0].length()+1));
		    Value_INFO[1].sprintf("%s", buffer);
		    if( temp == Value_INFO[1] )
		    {
			memset(&buffer, 0, sizeof(buffer));
			index = 2;			
		    }
		    else
		    {
			memset(&Value_code, 0, sizeof(Value_code));
			break; //break -------> LOOP : for(int j = 0 ; j < strlen(Value_code) ; j++)
		    }
		    
		}
		else if( index == 2 )
		{
		    QString message;
		    char recevie_message[100];
		    memset(&recevie_message, 0, sizeof(recevie_message));
		    int length;
		    length = Value_INFO[0].length() + Value_INFO[1].length();
    		    strncpy(buffer, Value_code + length + 2, j - (length+2));
		    Value_INFO[2].sprintf("%s", buffer);
		    strcat(Send_message, buffer);
		    if( address_check == false)
		    {
			write(fd[1], Send_message, strlen(Send_message));
			read(fd_p[0], recevie_message, sizeof(recevie_message));
			message.sprintf("Result [  %s  ]", recevie_message);
			V_R_Table->setText(V_R_Table->currentRow(), 1, message);
		    }
		    else
		    {
			QString t;
			if( array_check )
			{
			    void *fp;
			    sscanf( buffer, "%x", &fp);
			    t.sprintf("%x", ((char *)fp+array_byte * atoi(VR_array_num)));
//			    t.sprintf("%s + ( %d * %s )", buffer, array_byte, VR_array_num);
			}
			else
			    t.sprintf("%s", buffer);
			message.sprintf("Result [  %s  ]", t.ascii());
			V_R_Table->setText(V_R_Table->currentRow(), 1, message );
		    }
		    return true;
		}
		else if( index == 3)
		{
		    QString temp1;
    		    strncpy(buffer, Value_code + Value_INFO[0].length() + 1, j - (Value_INFO[0].length()+1));
		    temp1.sprintf("%s/%s",Value_INFO[0].ascii(), buffer);
		    array_size = atoi(buffer);
		    Value_INFO[0].sprintf("%s", temp1.ascii());
		    if( char_flag == true )
		    {
			
		    }
		    else if( array_size > atoi( VR_array_num))
		    {
			strcat( Send_message , VR_array_num );
			strcat( Send_message, "/");
		    }
		    else
		    {
			break;			
		    }
		    memset(&buffer, 0, sizeof(buffer));
		    index = 1;
		}
	    }

	}

    }
    if( value_text == Gloval__Value_list)
        V_R_Table->setText(V_R_Table->currentRow(), 1, "This is not Value in this program!!");
    return false;

}

void Debuger_Form::Cmd_Remove_BP_clicked()
{
    

    QString break_line;
    int line, col, temp = 0;
    pText[Debuger_Tab->indexOf(Debuger_Tab->currentPage())]->getCursorPosition(&line, &col);
    break_line = Make_Break_Code(Debuger_Tab->indexOf(Debuger_Tab->currentPage()), line);
    if( !Check_Break_Point( atoi(break_line.ascii())))//Check Break Line
    {
	for(int i = 0 ; i < Break_index ; i++)
	{
	    if( Break_list[i] == atoi(break_line.ascii()))
	    {
		pText[Debuger_Tab->indexOf(Debuger_Tab->currentPage())]->setParagraphBackgroundColor(line, Qt::white);
		temp++;
		Break_index--;
	    }
	    Break_list[i] = Break_list[temp++];
	}
    }

}


void Debuger_Form::Cmd_Start_clicked()
{
    for(int i = 0 ; i < 60 ; i++)
    {
	V_R_Table->clearCell( i, 0);
	V_R_Table->clearCell(i, 1);
	
    }
    Terminal->clear();
    system("rm /G_Studio/Debugger/Value_list.txt");
    QString removefile;
    for( int i = 0 ; i < Text_index ; i++)
    {
	removefile.sprintf("%d.txt", i);
	system("rm /G_Studio/Debugger/"+ removefile);
    }
    QColor color(255, 155, 155);
    for( int i = 0 ;  i < 30 ; i++)
	Debuging_line[i] = -1;

    char exe[100];
    memset(&exe, 0, sizeof(exe));
    strncpy(exe, mainform->ProName.ascii(), mainform->ProName.length() -3);
    QString exe_file;
    exe_file.sprintf("%s", exe);
    system("rm "+mainform->Path + exe_file);
    system("rm "+mainform->Path + "*.o");
    Cmd_Next_Step->setDisabled(false);
    Cmd_Next_Break->setDisabled(false);
    Cmd_Set_BreakPoint->setDisabled(true);
    Cmd_remove_Break_Point->setDisabled(true);
    Cmd_No_Break->setDisabled(false);
    Cmd_Start_Debuging->setDisabled(true);
    int pid;
     if(pipe(fd) == -1 || pipe(fd_p) == -1 )
    {
  	QMessageBox::question(this, "Error", "Error");
	Cmd_Start_Debuging->setDisabled(false);
	return ;
    }

////////////////////// Change Debugging Mode  //////////////////////////////////////////////////////////////////////////
   
    for( File_index = 0 ; File_index < Text_index ; File_index++) // Start Checking All Files in Project
    {
	Debuger_Tab->showPage(Debuger_Tab->page(File_index));// Show Debuger page
	if( Debuger_Tab->tabLabel(Debuger_Tab->page(File_index)).endsWith(".c"))
	{
	    for( Line_index = 0 ; Line_index < pText[File_index]->paragraphs () ; Line_index++)// Start Checking All Lines in Project
	    {
		if(Function_FSA( pText[File_index]->text(Line_index)) == true)//Searching Function
		{
		    Line_FSA();
		}
	    }
	    
	}// End ... for( int Line_index = 0 ; Line_index < pText[File_index]->count() ; Line_index++)  : Checking All Line In File
	
    }// End ... for( int File_index = 0 ; File_index < Text_index ; File_index++): Checking All Files In Project
///////////////////////// Value & Reference Table Algolism //////////////////////////////////////////////////////////////    
    QStringList Gloval_List[30];
    QString Gloval_Value;
     for( File_index = 0 ; File_index < Text_index ; File_index++) // Start Checking All Files in Project
    {
	Debuger_Tab->showPage(Debuger_Tab->page(File_index));// Show Debuger page

	if( Debuger_Tab->tabLabel(Debuger_Tab->page(File_index)).endsWith(".c"))
	{
	    for( Line_index = 0 ; Line_index <pText[File_index]->paragraphs () ; Line_index++)// Start Checking All Lines in Project
	    {
		if(Function_FSA( pText[File_index]->text(Line_index)) == true)//Searching Function
		{
		    Value_FSA();
		}
		else
		{
		    Gloval_Value = Gloval_value_FSA("1");
		    if( Gloval_Value != "Null")
		    {
			char d[1000];
			memset( &d, 0, sizeof(d));
			strncpy(d ,  Gloval_Value.ascii(),   Gloval_Value.length() - 14);
			Gloval_Value.sprintf("%sG_v_a_l_u_e( %d , t_e_m_p);", d, File_index);
			Gloval_List[File_index] << Gloval_Value;
		    }
		}
	    }// End ... for( int Line_index = 0 ; Line_index < pText[File_index]->count() ; Line_index++)  : Checking All Line In File
	    
	}
    }// End ... for( int File_index = 0 ; File_index < Text_index ; File_index++): Checking All Files In Project
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
     char CodeLine[1000];
    main_flag = false;
    QString main_code;
    QString parameter_Value;
    
    for( File_index = 0 ; File_index < Text_index ; File_index++) // Start Checking All Files in Project
    {	
	Debuger_Tab->showPage(Debuger_Tab->page(File_index));// Show Debuger page
	if( Debuger_Tab->tabLabel(Debuger_Tab->page(File_index)).endsWith(".c"))
	{
	    for( Line_index = 0 ; Line_index < pText[File_index]->paragraphs () ; Line_index++)// Start Checking All Lines in Project
	    {
		if(Function_FSA( pText[File_index]->text(Line_index)) == true)//Searching Function
		{
		   parameter_Value = Parameter_Value();
		    memset(&CodeLine, 0, sizeof(CodeLine));
		    strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
		    for(int i = 0 ; i < strlen(CodeLine) ; i++)
		    {
			if(CodeLine[i] == '{')
			{			    			   
				QStringList::ConstIterator it = Gloval_List[File_index].constBegin();
				QString Value;
				Value.sprintf("Gloval_cl_e_a_r(%d);", File_index);
				while( it != Gloval_List[File_index].constEnd())
				{
				    Value.append(*it);
				    it++;
				}			
			    pText[File_index]->insertAt("Start();"+ Value+ parameter_Value, Line_index, i+1);
			    break;
			}
		    }
		    main_flag = Find_main_Func();
		    Func_End_FSA();
		    memset(&CodeLine, 0, sizeof(CodeLine));
		    strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
		    for(int i = 0 ; i < strlen(CodeLine) ; i++)
		    {
			if(CodeLine[i] == '}')
			{
			    if( main_flag == true )
			    {
				main_code.sprintf("BP(%d,  %d, %d, 2);",atoi(Make_Break_Code(File_index, Line_index).ascii()),fd[0], fd_p[1]);
				pText[File_index]->insertAt(main_code + "End();", Line_index, i);
			    }
			    else
			    {
			//	main_code.sprintf("BP(%d,  %d, %d, 5);",atoi(Make_Break_Code(File_index, Line_index).ascii()),fd[0], fd_p[1]);
			//	pText[File_index]->insertAt(main_code + "End();", Line_index, i);
				pText[File_index]->insertAt("End();", Line_index, i);
			    }
			    break;
			}
					
		    }

		}
	    }// End ... for( int Line_index = 0 ; Line_index < pText[File_index]->count() ; Line_index++)  : Checking All Line In File
	    
	}
    }// End ... for( int File_index = 0 ; File_index < Text_index ; File_index++): Checking All Files In Project
//////////////////Write Debuger Header File ( #include < Debuger.h > )/////////////////////////////////////////////////  
    for( File_index = 0 ; File_index < Text_index ; File_index++) // Start Checking All Files in Project
    {
	if( Debuger_Tab->tabLabel(Debuger_Tab->page(File_index)).endsWith(".c"))
	{
	    pText[File_index]->insertAt("#include <Debuger.h>", 0 , 0);
	    pText[File_index]->setCursorPosition( 0 , 20);
	    pText[File_index]->doKeyboardAction(QTextEdit::ActionReturn);
    	    pText[File_index]->insertAt("char t_e_m_p[1000];", 1 , 0);
	    pText[File_index]->setCursorPosition( 1 , 19);
	    pText[File_index]->doKeyboardAction(QTextEdit::ActionReturn);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}
    }// End ... for( int File_index = 0 ; File_index < Text_index ; File_index++): Checking All Files In Project

////////////////////////////// Complie GCC Using QProcess of make commend ///////////////////////////
    Save_File();
    QProcess *temp_proc;    
    QDir dir;
    dir.setPath(mainform->Path);
    temp_proc = new QProcess(this);
    temp_proc->setWorkingDirectory(dir);
    temp_proc->addArgument("make");
    if(!temp_proc->start())
    {
	QMessageBox::critical(this, "Make Error", "Make Error");
	return ;
    }
//////////////////////////////////////////////////////////////////////////////////////////////////
    QString Label_text;
    for(int j = 0 ; j <Text_index; j++)
    {
	Label_text = mainform->Tab_Editor->tabLabel ( mainform->Tab_Editor->page(j));
	for( int i = 0 ; i < Text_index ; i++)
	{
	    if( Label_text == Debuger_Tab->tabLabel( Debuger_Tab->page(i)))
	    {
		pText[i]->setText(mainform->pText[j]->text());
		break;
	    }
	}
    }
//////////////////////////////////////////////////////////////////////////////////////////////////
    while( temp_proc->isRunning() == true)
    {
	;
    }
    delete temp_proc;
//////////////////////////////////////////////////////////////////////////////////////////////////  
   Save_File();
    QString a;
    char temp[10];
    char page[3];
    QColor step_color(155 ,155,255);
    for( int i = 0 ; i < Break_index ; i++)
    {
	memset(&temp, 0, sizeof(temp));
	memset(&page, 0, sizeof(page));
	if( Break_list[i] < 10000)
	{
    	    pText[0]->setParagraphBackgroundColor(Break_list[i], color);
	}
	else if( Break_list[i] < 100000)
	{
    	   a.sprintf("0%d", Break_list[i]);
    	   strcpy(temp, a.ascii());
    	   strncpy(page, temp, 2);
    	   pText[atoi(page)]->setParagraphBackgroundColor(atoi(temp+2), color);
	}
	else
	{
	    a.sprintf("%d", Break_list[i]);
	    strcpy(temp, a.ascii());
	    strncpy(page, temp, 2);
	    pText[atoi(page)]->setParagraphBackgroundColor(atoi(temp+2), color);
    	}
    }
     proc = new QProcess(this);
     char temp_exe[100];
     memset(temp_exe, 0, sizeof(temp_exe));
     strncpy(temp_exe, mainform->ProName.ascii(), mainform->ProName.length()-3);
     QString ttt;
     ttt.sprintf("%s", temp_exe);
    proc->addArgument( mainform->Path + ttt);
    connect(proc, SIGNAL(readyReadStdout()), this, SLOT(readFromStdout()));
    connect(proc, SIGNAL(processExited()), this, SLOT(process_end()));
    connect(proc, SIGNAL(wroteToStdin()), this, SLOT(sendFromStdin()));
    if( !proc->start())
    {
	QMessageBox::critical(this, "Can not do Debugging", "Can not do Debugging!!\nPlease Check Source Code!!");
	delete proc;
	Cmd_Set_BreakPoint->setDisabled(false);
	Cmd_remove_Break_Point->setDisabled(false);
	return ;
    }
    Terminal->setEnabled(true);
///////////////////////////////////////////////////////////////////////////////////////////////////////
    
    char Working_line[10];
    char debuger_page[3];
    QString temp_line;
    bool temp_flag = false;
    QFont Font( "Sans Serif", 11, QFont::Bold );
    memset(&Working_line, 0, sizeof(Working_line));
    read(fd_p[0], Working_line, 10);
    if( Working_line[0] == '/')
    {
	Cmd_Next_Step->setEnabled(false);
	Cmd_Next_Break->setEnabled(false);
	ExcutionTerminal->setFont(Font);
	temp_line.sprintf("%s", Working_line + 1);
	memset(&Working_line, 0, sizeof(Working_line));
	strcpy(Working_line, temp_line.ascii());

    }
    else if( Working_line[0] == '@' )
    {
	 temp_line.sprintf("%s", Working_line + 1);
	memset(&Working_line, 0, sizeof(Working_line));
	strcpy(Working_line,  temp_line.ascii());
	temp_flag = true;	
	
    }
    if( atoi(Working_line) < 10 )
	temp_line.sprintf("00000%d", atoi(Working_line));
    else if( atoi(Working_line) < 100 )
	temp_line.sprintf("0000%d", atoi(Working_line));
    else if( atoi(Working_line) < 1000 )
	temp_line.sprintf("000%d", atoi(Working_line));
    else if( atoi(Working_line) < 10000 )
	temp_line.sprintf("00%d", atoi(Working_line));
    else if( atoi(Working_line) < 100000 )
	temp_line.sprintf("0%d", atoi(Working_line));
    else
	temp_line.sprintf("%d", atoi(Working_line));
    strcpy( Working_line, temp_line.ascii());
    strncpy(debuger_page, Working_line, 2);
    Debuger_Tab->showPage(Debuger_Tab->page(atoi(debuger_page)));
    pText[atoi(debuger_page)]->setCursorPosition( atoi(Working_line + 2) , 0);
    if( pText[atoi(debuger_page)]->paragraphBackgroundColor( atoi(Working_line + 2)) != color)
    {
	pText[atoi(debuger_page)]->setParagraphBackgroundColor( atoi(Working_line + 2) , step_color );
	Debuging_line[atoi(debuger_page)] = atoi(Working_line+2);
    }
    if(temp_flag)
    {
	Set_Variable_list();	
	Set_Gloval_Variable_list();
    }
//////////////////////////////////////////////////////////////////////////////////////////////////////////
}
QString Debuger_Form::Parameter_Value()
{
    char Parameter[1000];
    bool flag = false;
    char temp1[100];
    memset(&temp1, 0, sizeof(temp1));
    QStringList value;
    memset(&Parameter, 0, sizeof(Parameter));
    int temp;
    for(int i = 0 ; i < 100 ; i++)
    {
	if( pText[File_index]->text(Line_index-i).contains(")") != 0)
	{
	    strcpy(Parameter, pText[File_index]->text(Line_index-i).ascii());
	    break;
	}
    }

    for( int i = 0 ; i < strlen( Parameter ) ; i++)
    {
	if(Parameter[i] == '(' )
	{
	    flag = true;
	    temp = i;
	}
	else if( Parameter[i] == ')' )
	{
	    if( flag == false)
	    {
		strncpy( temp1, Parameter + temp+1, i - (temp+1));
		strcat(temp1, ";");
		value << temp1;
		temp = i;
		memset(&temp1, 0, sizeof(temp1));
	    }
	    break;
	}
	else if( Parameter[i] == ',')
	{
	    strncpy( temp1, Parameter + temp+1, i - (temp+1));
	    strcat(temp1, ";");
	    value << temp1;
	    temp = i;
	    memset(&temp1, 0, sizeof(temp1));
	}
	else if( Parameter[i] != ' ' && Parameter[i] != '	' && flag)
	{
	    flag  = false;
	}
	    
    }
    QString Parameta_Value;
    QString return_Value;
    QStringList::ConstIterator it = value.constBegin();
    while( it != value.constEnd())
    {
	Parameta_Value = Gloval_value_FSA(*it);
	if( Parameta_Value != "Null")
	{
	    return_Value.append(Parameta_Value);
	}
	it++;
    }

return return_Value;
}


void Debuger_Form::paintEvent( QPaintEvent * )
{
    QRect Value_rect = Value_View->rect();
    QRect Value_Table_rect(Value_rect.left()+5, Value_rect.top() + 20, Value_rect.right() - 13, Value_rect.bottom() - 30);
    QRect Tab_rect = Debuger_Tab->rect();//Get the tab Size( rect )
    QRect Debuger_rect = ExcutionTerminal->rect();     
    QRect Text_rect(Tab_rect.left()+5, Tab_rect.top() +5 , Tab_rect.right() -13, Tab_rect.bottom() -43);//Set TextEidt Rect
    QRect Terminal_rect(Debuger_rect.left()+5, Debuger_rect.top() +15 , Debuger_rect.right() -13, Debuger_rect.bottom() -20);
    for(int i = 0 ; i < Text_index ; i++)
	pText[i]->setGeometry(Text_rect);
    Terminal->setGeometry(Terminal_rect);
    V_R_Table->setGeometry(Value_Table_rect);
    V_R_Table->setColumnWidth(1, Value_rect.right() - 190);
}


void Debuger_Form::readFromStdout()
{
   Terminal->insert( proc->readStdout());
}


void Debuger_Form::process_end()
{
    variable_list->clear();    
    QMessageBox::information(this, "Finish", "Debugging Finish");
    delete proc;
    QColor color(255, 155, 155);
    Terminal->setEnabled(false);
    Cmd_Start_Debuging->setDisabled(false);    
    Cmd_Next_Step->setDisabled(true);
    Cmd_Next_Break->setDisabled(true); 
    Cmd_No_Break->setDisabled(true);
    Cmd_Set_BreakPoint->setDisabled(false);
    Cmd_remove_Break_Point->setDisabled(false);
    for( int i = 0 ; i <Text_index ; i++)
    {
	if( pText[i]->paragraphBackgroundColor(Debuging_line[i] ) != color )
	{
	    pText[i]->setParagraphBackgroundColor( Debuging_line[i], Qt::white );
	}
    }
    FILE *fp;
    fp = fopen("/G_Studio/Debugger/Value_list.txt", "w");
    fclose(fp);
    mainform->fileSave();
}


void Debuger_Form::sendFromStdin()
{
    Terminal->insert( proc->readStdout());
}


void Debuger_Form::Text_Cursor_Move()
{
    Terminal->moveCursor(QTextEdit::MoveEnd, false);
}


void Debuger_Form::Return_Press()
{
    
}

void Debuger_Form::Text_Changed()
{
    Terminal->getCursorPosition(&Terminal_Line, &Terminal_Col);
    	    VR_Click_flag = false;
}


bool Debuger_Form::eventFilter( QObject *obj, QEvent *ev )
{ 
    QFont Font( "Sans Serif", 9, QFont::Normal );
    if(ev->type() == QEvent::KeyPress && (obj == pText[ Debuger_Tab->currentPageIndex()] || obj == Terminal))
    {
	QKeyEvent *k = (QKeyEvent*)ev;
	QString a;
	if( k->key() == Qt::Key_F6 )
	{
	    if(Cmd_Next_Step->isEnabled() == true)
	    { 
		Cmd_Next_Step_clicked();
	    }
	}
	else if( k->key() == Qt::Key_F7 )
	{
	    if(Cmd_Next_Break->isEnabled() == true)
	    {
		Cmd_Next_Break_clicked();
	    }
	}
	else if(  k->key() == Qt::Key_F2 &&  obj == pText[ Debuger_Tab->currentPageIndex()])
	{
	    if(Cmd_Set_BreakPoint->isEnabled() == true)
	    {
		Cmd_SetBreakPoint_Clicked();
	    }
	}
	else if(  k->key() == Qt::Key_F3 &&  obj == pText[ Debuger_Tab->currentPageIndex()])
	{
	    if(Cmd_remove_Break_Point->isEnabled() == true)
	    {
		Cmd_Remove_BP_clicked();
	    }
	}
	else if(  k->key() == Qt::Key_F5 &&  obj == pText[ Debuger_Tab->currentPageIndex()])
	{
	    if(Cmd_Start_Debuging->isEnabled() == true)
	    {
		Cmd_Start_clicked();
	    }
	}
	else if( k->key() == Qt::Key_F8 )
	{
	}
	else if( (k->key() == 4100 || k->key() == 4101) && obj == pText[ Debuger_Tab->currentPageIndex()])
	{
	}
	else if(k->key() == 4144 || k->key() == 4094 ||k->key() == 4145 ||k->key() == 4146 ||k->key() == 4147 ||k->key() == 4148 ||k->key() == 4149 ||k->key() == 4150 ||k->key() == 4151 ||k->key() == 4152 ||k->key() == 4153 ||k->key() == 4154 ||k->key() == 4155 ||k->key() == 4134 ||k->key() == 4104 ||k->key() == 4128 ||k->key() == 4129 ||k->key() == 4179 ||k->key() == 4131 ||k->key() == 4114 ||k->key() == 4115 ||k->key() == 4117 ||k->key() == 4116 ||k->key() == 4102 ||k->key() == 4103 ||k->key() == 4113 ||k->key() == 4112 ||k->key() == 4118 ||k->key() == 4119 ||k->key() == 4133)
	{

	}
	else if( k->key() == 4099)//BackSpaceKey
	{
	    if( data_buffer->text().length() != 0 )
	    {
		Terminal->doKeyboardAction(QTextEdit::ActionBackspace); 
		data_buffer->backspace();
	    }
	}
	else if( k->key() == 4100 || k->key() == 4101)//EnterKey
	{
	      proc->writeToStdin(data_buffer->text() + "\n" );
	      data_buffer->clear();
	      Terminal->doKeyboardAction(QTextEdit::ActionReturn);
	      Cmd_Next_Step->setEnabled(true);
	      Cmd_Next_Break->setEnabled(true);
	      Terminal->setFont(Font);
	      ExcutionTerminal->setFont(Font);
	 }
	else
	{
	    Terminal->insert(k->text());
	    data_buffer->insert(k->text());
	}
	    
    }
    else
    {
	
    }
}


void Debuger_Form::Save_File()
{
    QString filename;
    QFile file;
    for(int i = 0 ; i < Text_index; i++)
    {
	filename.sprintf("%s%s", mainform->Path.ascii(), Debuger_Tab->label(i).ascii());
	file.setName(filename);
	if(!file.open(IO_WriteOnly))
	{
                	QMessageBox::warning(this, "file Save Error\n\n", filename);
	 }
	else
	{
	    QTextStream stream(&file);
	    stream << pText[i]->text();
	   file.close();
	}
    }
}


bool Debuger_Form::Function_FSA( QString Line_Code )// For Searching Function
{
    bool FSA_flag = false;
    bool Function_flag = false;
    bool string_comment_flag = false;
    bool midle = false; // Check Token '  {  '
    bool small = false; // Check Token ' ( '
    char CodeLine[1000];
    char Token[100];
    int Token_index = 0;
    memset(&CodeLine, 0, sizeof(CodeLine));
    memset(&Token, 0, sizeof(Token));
    strcpy(CodeLine, Line_Code.ascii());
    
    for(int i = 0 ; i < strlen(CodeLine) ; i++) // Create Token Strem And Token Checking
    {
	
	if( CodeLine[i] == '"')
	{
	    if( string_comment_flag == false)
		string_comment_flag = true;
	    else
		string_comment_flag - false;
	}
	else if(CodeLine[i] == '/' && CodeLine[i+1] == '/'&& string_comment_flag == false)// if Sentance is Commnet '//'
	{
//	    QMessageBox::question(this, "Comment", CodeLine);
	    return false; 
	}
	else if(CodeLine[i] == '/' && CodeLine[i+1] == '*'&& string_comment_flag == false)// if Sentance is Commnet '/*'
	{
	   i =  Comment_Filter( i );
	   memset(&CodeLine, 0, sizeof(CodeLine));
	   strcpy(CodeLine, Line_Code.ascii());
	}
	else if( CodeLine[i] == ' ' || CodeLine[i] == '	' && string_comment_flag == false )
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    //Checking Token && inisialize of Token
	}
	else if( CodeLine[i] == '(' && string_comment_flag == false )
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    Function_flag = true;
	    //Checking Token && inisialize of Token
	    if( FSA_flag == false )
	    {
		FSA_flag = true;
		small = true;
	    }//End if( FSA_flag == false )
	}
	else if(CodeLine[i] == ')' && string_comment_flag == false)
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    //Checking Token && inisialize of Token
	    if( FSA_flag == true )
	    {
		FSA_flag = false;
	    }//End if( FSA_flag == false )
	}
	else if(CodeLine[i] == ';' && string_comment_flag == false)
	{
	    return false;
	}
	else if(CodeLine[i] == '{' && string_comment_flag == false)
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    if( FSA_flag == false && small == true && Function_flag == true )
	    {
		 midle = true;
		return true;
	    }
	}
	else
	{
	    if( string_comment_flag == false)
	    {
		Token[Token_index] = CodeLine[i];
		Token_index++;
	    }
	}

    }//End for(int i = 0 ; i < strlen(CodeLine) + 1 ; i++) : Lincode End
    
    if(midle == false )
    {
	while(1)
	{
	    memset(&CodeLine, 0, sizeof(CodeLine));
	    if(Line_index < pText[File_index]->paragraphs ()-1)
		strcpy(CodeLine, pText[File_index]->text(++Line_index).ascii());
	    else
		return false;
	    
	    for(int i = 0  ; i < strlen(CodeLine) ; i++)
	    {
		if(CodeLine[i] == ' ' || CodeLine[i] == '	')
		{
		    ;
		}
		else if(CodeLine[i] == '{')
		{ 
		    return true;
		}
		else
		{
		    --Line_index;
		    return false;
		}
	    }
	}
    }

}


void Debuger_Form::Line_FSA()
{
    bool struct_flag = false;
    bool scanf_flag = false;
    bool 	string_comment_flag = false;
    int midle_flag = 1;
    char CodeLine[1000];
    char Token[100];
    int Token_index = 0;
    memset(&CodeLine, 0, sizeof(CodeLine));
    memset(&Token, 0, sizeof(Token));
    QString kkk;
    
    while(midle_flag != 0)
    {
	memset(&CodeLine, 0, sizeof(CodeLine));

	if( pText[File_index]->paragraphs ()-1 == Line_index )
	    return;
	else
	    strcpy(CodeLine, pText[File_index]->text(++Line_index).ascii());
	
	for( int i = 0 ; i < strlen(CodeLine)+1 ; i++)
	{
	    if( CodeLine[i] == '"')
	    {
		if( string_comment_flag == false)
		    string_comment_flag = true;
		else
		    string_comment_flag = false;
	    }
	    else if(CodeLine[i] == '/' && CodeLine[i+1] == '/'&& string_comment_flag == false)// if Sentance is Commnet '//'
	    {
		break; 
	    }
	    else if(CodeLine[i] == '/' && CodeLine[i+1] == '*'&& string_comment_flag == false)// if Sentance is Commnet '/*'
	    {
		QString Line_Code;
		i =  Comment_Filter( i );
		memset(&CodeLine, 0, sizeof(CodeLine));
		Line_Code = pText[File_index]->text(Line_index);
		strcpy(CodeLine, Line_Code.ascii());
	    }
	    else if( (CodeLine[i] == ' ' || CodeLine[i] == '	' || CodeLine[i] == '(') && string_comment_flag == false)
	    {
		if( strcmp( Token, "struct") == 0)
		{
		    struct_flag = true;
		}
		else if( strcmp( Token, "scanf") == 0 || strcmp( Token, "fscanf") == 0|| strcmp( Token, "fgets") == 0|| strcmp( Token, "getc") == 0|| strcmp( Token, "getchar") == 0 || strcmp( Token, "gets") == 0 )
		{
		    scanf_flag = true;
		}
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
		//Checking Token && inisialize of Token
	    }
	    else if(CodeLine[i] == ';' && struct_flag == false && 	string_comment_flag == false) 
	    {
		int temp_num;
		QString a;
		QString dd;
		BP_Function_Code.sprintf("BP( %d, %d, %d, fg);",atoi(Make_Break_Code(File_index, Line_index).ascii()),fd[0], fd_p[1]);
		Break_Point_Code.sprintf("BP(%d,  %d, %d, 0);",atoi(Make_Break_Code(File_index, Line_index).ascii()),fd[0], fd_p[1]);
		dd.sprintf("BP(%d,  %d, %d, 2);",atoi(Make_Break_Code(File_index, Line_index).ascii()),fd[0], fd_p[1]);
		temp_num = Filter_For_Loop( CodeLine );// For Fitering ForLoop
		if( temp_num == -1)
		{
		    if(Function_Jerge())
		    {
			if(!Check_Break_Point(atoi(Make_Break_Code(File_index, Line_index).ascii())))
			    pText[File_index]->insertAt("{" + Break_Point_Code, Line_index, 0);		    
			else
			    pText[File_index]->insertAt("{" + BP_Function_Code, Line_index, 0);
			
			pText[File_index]->setCursorPosition( Line_index , 24);
			while( a != ";")
			{
			    pText[File_index]->removeSelection ( 0 );
			    pText[File_index]->moveCursor(QTextEdit::MoveForward, true);
			    a.sprintf("%s",  pText[File_index]->selectedText().ascii());
			    if( a == snprintf_code2->text() && string_comment_flag == false)
			    {
				string_comment_flag = true;
			    }
			    else if( a == snprintf_code2->text() && string_comment_flag == true)
			    {
				string_comment_flag = false;
			    }
			    else if( string_comment_flag == true )
			    {
				a.sprintf("d");
			    }
			}
			pText[File_index]->removeSelection ( 0 );
			pText[File_index]->insert("}");
		    }
		    else if( scanf_flag == true)
		    {
			pText[File_index]->insertAt(dd, Line_index, 0);		    
			scanf_flag = false;
		    }
		    else if(!Check_Break_Point(atoi(Make_Break_Code(File_index, Line_index).ascii())))
			pText[File_index]->insertAt(Break_Point_Code, Line_index, 0);		    
		    else
			pText[File_index]->insertAt(BP_Function_Code, Line_index, 0);
		    break;
		}
		else
		{
		    i = temp_num;		    
		}
	    }
	    else if(CodeLine[i] == '{' && string_comment_flag == false)
	    {
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
		midle_flag++;
	    }
	    else if(CodeLine[i] == '}' && string_comment_flag == false)
	    {
		if( struct_flag )
		{
		    struct_flag = false;
		    break;
		}
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
		midle_flag--;
	    }	    
	    else
	    {
		if(string_comment_flag == false)
		{
		    Token[Token_index] = CodeLine[i];
		    Token_index++;
		}
	    }
	}
    }

}

void Debuger_Form::Value_FSA()
{
    int midle_flag = 1;
    bool struct_flag = false;
    bool string_comment_flag = false;
    char CodeLine[1000];
    char Token[100];
    int Token_index = 0;
    QString snprintf_code;
    memset(&CodeLine, 0, sizeof(CodeLine));
    memset(&Token, 0, sizeof(Token));


    while(midle_flag != 0)
    {
	memset(&CodeLine, 0, sizeof(CodeLine));

	if( pText[File_index]->paragraphs ()-1 == Line_index )
	{
	    return;
	}
	else
	{
	    strcpy(CodeLine, pText[File_index]->text(++Line_index).ascii());
	}

	memset(&Token, 0, sizeof(Token));
	for( int i = 0 ; i < strlen(CodeLine)+1 ; i++)
	{
	    if( CodeLine[i] == '"')
	    {
		if( string_comment_flag == false)
		    string_comment_flag = true;
		else
		    string_comment_flag = false;
	    }
	    if(CodeLine[i] == '/' && CodeLine[i+1] == '/' &&string_comment_flag == false)
	    {
		break;
	    }
	    else if(CodeLine[i] == '/' && CodeLine[i+1] == '*' && string_comment_flag == false)
	    {
		i = Comment_Filter( i )+1;
		memset(&CodeLine, 0, sizeof(CodeLine));
		strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
	    }
	    else if( (CodeLine[i] == ' ' || CodeLine[i] == '	') && string_comment_flag == false)
	    {
		if( struct_flag )
		{
		    
		}
		else if( strcmp( Token , "int") == 0 || strcmp( Token , "int*") == 0)
		{
		    snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		    if( strcmp("break", snprintf_code.ascii()) == 0)
			break;
		    pText[File_index]->insertAt(snprintf_code, Line_index, i+1);
		    memset(&Token, 0, sizeof(Token));
		    break;
		}
		else if( strcmp( Token , "char") == 0 || strcmp( Token , "char*") == 0)
		{ 		  
		    snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		    if( strcmp("break", snprintf_code.ascii()) == 0)
			break;
		    pText[File_index]->insertAt(snprintf_code, Line_index, i+1);
		    memset(&Token, 0, sizeof(Token));
		    break;
		}
		else if( strcmp( Token , "short") == 0 || strcmp( Token , "short*") == 0)
		{	    
		    snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		    if( strcmp("break", snprintf_code.ascii()) == 0)
			break;
		    pText[File_index]->insertAt(snprintf_code, Line_index, i+1);
		    memset(&Token, 0, sizeof(Token));
		    break;
		}
		else if( strcmp( Token , "float") == 0 || strcmp( Token , "float*") == 0)
		{
		    snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		    if( strcmp("break", snprintf_code.ascii()) == 0)
			break;
		    
		    pText[File_index]->insertAt(snprintf_code, Line_index, i+1);
		    memset(&Token, 0, sizeof(Token));
		    break;
		}
		else if( strcmp( Token , "double") == 0 || strcmp( Token , "double*") == 0)
		{
		    snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		    if( strcmp("break", snprintf_code.ascii()) == 0)
			break;
		    
		    pText[File_index]->insertAt(snprintf_code, Line_index, i+1);
		    memset(&Token, 0, sizeof(Token));
		    break;
		}
		else if( strcmp( Token , "bool") == 0 )
		{
		    snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		    if( strcmp("break", snprintf_code.ascii()) == 0)
			break;
		    
		    pText[File_index]->insertAt(snprintf_code, Line_index, i+1);
		    memset(&Token, 0, sizeof(Token));
		    break;
		}
		else if( strcmp( Token , "long") == 0 || strcmp( Token , "long*") == 0)
		{
		    snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		    if( strcmp("break", snprintf_code.ascii()) == 0)
			break;
		    pText[File_index]->insertAt(snprintf_code, Line_index, i+1);
		    memset(&Token, 0, sizeof(Token));
		    break;
		}
		else if( strcmp( Token, "struct" ) == 0)
		{
		    struct_flag = true;
		    memset(&Token, 0, sizeof(Token));
		}
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
		//Checking Token && inisialize of Token
	    }
	    else if( (CodeLine[i] == '(' || CodeLine[i] == ')' ) && string_comment_flag == false)
	    {
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
	    }
	    else if((CodeLine[i] == ';' ||CodeLine[i] == ',' )&& string_comment_flag == false) 
	    {
	
	    }
	    else if(CodeLine[i] == '{'&& string_comment_flag == false)
	    {
		midle_flag++;
	    }
	    else if(CodeLine[i] == '}'&& string_comment_flag == false)
	    {
		if( struct_flag )
		    struct_flag = false;
		midle_flag--;
	    }	    
	    else
	    {
		if(string_comment_flag == false)
		{
		    Token[Token_index] = CodeLine[i];
		    Token_index++;
		}
	    }
	}
    }
}


QString Debuger_Form::Make_Value_Code( char Code_Line[1000], char Token[100], int * j )
{
    bool initialization_flag = true;
    bool pointer_flag = true;
    bool char_array_initialization_flag = true;
    bool array_initialization_flag = true;
    bool array_flag = true;
    int array_index;
    char array_num[20];
    char array_Value[100];
    char pointer_value[100];
    char Value[100];
    int Value_index = 0;
    char line1[1000];
    char line2[1000];
    memset(&line1, 0, sizeof(line1));
    memset(&line2, 0, sizeof(line2));    
    memset(&array_Value, 0, sizeof(array_Value));        
    memset(&array_num, 0, sizeof(array_num));            
    QString temp1;
    QString temp2;
    strcpy(line1, snprintf_code1->text().ascii());
    strcpy(line2, snprintf_code2->text().ascii());
    memset(&Value, 0, sizeof(Value));
   if( Token[strlen(Token)-1] == '*')
    {
       memset(&pointer_value, 0, sizeof(pointer_value));
       strcat(pointer_value, "*");
       strncat(pointer_value, Token, strlen(Token)-1 );
       pointer_flag = false;
   }
   
    for( int i = *j ; i < strlen(Code_Line) ; i++)
    {
	if( Code_Line[i] == ' ' || Code_Line[i] == '	'&& array_initialization_flag == true && char_array_initialization_flag == true)
	{
	    
	}
	else if( Code_Line[i] == '*'&& array_initialization_flag == true && char_array_initialization_flag == true)
	{
	    memset(&pointer_value, 0, sizeof(pointer_value));
	    strcat(pointer_value, "*");
	    strcat(pointer_value, Token );
	    memset(&Value, 0, sizeof(Value));
	    Value_index = 0;
	    pointer_flag = false;
	}
	else if( (Code_Line[i] == '(' || Code_Line[i] == ')') && initialization_flag && array_initialization_flag )
	{
	    memset(&Value, 0, sizeof(Value));
	    strcpy(Value, "break");
	    temp1.sprintf( "%s", Value);
	    return temp1;
	}
	else if( Code_Line[i] == '=' && array_initialization_flag == true && char_array_initialization_flag == true)
	{
	    initialization_flag = false;	    
	}
	else if( Code_Line[i] == '['&& array_initialization_flag == true && char_array_initialization_flag == true)
	{
	    array_flag = false;
	    array_index = strlen(Value) ;
	}
	else if( Code_Line[i] == '{' && char_array_initialization_flag == true)
	{
	    array_initialization_flag =  false;
	}
	else if( Code_Line[i] == '}' && char_array_initialization_flag == true)
	{
	    array_initialization_flag = true;
	}
	else if( array_initialization_flag == true && Code_Line[i] == '"')
	{
	    if( char_array_initialization_flag == true)
		char_array_initialization_flag = false;
	    else
		char_array_initialization_flag = true;
	}
	else if( Code_Line[i] == ',' && array_initialization_flag == true && char_array_initialization_flag == true)
	{
	    if(array_flag)
	    {
		if( pointer_flag)
		{
		    temp1.sprintf("%s/%s/", Token, Value);
		    temp2.sprintf(",&%s", Value);
		}
		else
		{
		    temp1.sprintf("%s/%s/", pointer_value, Value);
		    temp2.sprintf(",&%s", Value);
		    pointer_flag = true;
		}
	    }
	    else
	    {
		strncpy(array_Value, Value, array_index);
		strncpy(array_num, Value + array_index , strlen(Value) - (array_index +1)); 
		if( pointer_flag )
		{
		    temp1.sprintf("^%s/%d/%s/", Token, atoi(array_num),array_Value);
		}
		else
		{
		    temp1.sprintf("^%s/%d/%s/", pointer_value, atoi(array_num),array_Value);
		    pointer_flag = true;
		}
		temp2.sprintf(",%s", array_Value);
		memset(&array_Value, 0, sizeof(array_Value));    
		memset(&array_num, 0, sizeof(array_num));            		
		array_flag = true;			
	    }
	    strcat(line1, temp1.ascii());
	    strcat(line1, snprintf_code4->text().ascii());
	    strcat(line2, temp2.ascii());
	    memset(&Value, 0, sizeof(Value));
	    Value_index = 0;
    	    initialization_flag = true; 

	}
	else if( Code_Line[i] == ';' && array_initialization_flag == true && char_array_initialization_flag == true)
	{
	    if(array_flag)
	    {
		if( pointer_flag)
		{
		    temp1.sprintf("%s/%s/", Token, Value);
		    temp2.sprintf(",&%s", Value);
		}
		else
		{
		    temp1.sprintf("%s/%s/", pointer_value, Value);
		    temp2.sprintf(",&%s", Value);	
		    pointer_flag = true;
		}
	    }
	    else
	    {
		strncpy(array_Value, Value, array_index);
		strncpy(array_num, Value + array_index , strlen(Value) - (array_index +1)); 
		if( pointer_flag )
		{
		    temp1.sprintf("^%s/%d/%s/", Token, atoi(array_num),array_Value);
		}
		else
		{
		    temp1.sprintf("^%s/%d/%s/", pointer_value, atoi(array_num),array_Value);
		    	    pointer_flag = true;
		}
		temp2.sprintf(",%s", array_Value);
		memset(&array_Value, 0, sizeof(array_Value));    
		memset(&array_num, 0, sizeof(array_num));            		
		array_flag = true;			
	    }
	    strcat(line1, temp1.ascii());
	    strcat(line1, snprintf_code4->text().ascii());
	    strcat(line2, temp2.ascii());
	    strcat(line2, snprintf_code3->text().ascii());
	    memset(&Value, 0, sizeof(Value));
	    Value_index = 0;
    	    initialization_flag = true; 
	    *j = i; 
	    break;
	}
	else if( initialization_flag == true && array_initialization_flag == true && char_array_initialization_flag == true)
	{
	    Value[Value_index] = Code_Line[i];
	    Value_index++;
	}
    }
    temp1.sprintf("%s%s", line1, line2);
    return temp1;

}

bool Debuger_Form::Function_Jerge()
{
    int i, k;
    char text[1000];
    for( i = 1 ; i < 100 ; i++)
    {
	memset(&text, 0, sizeof(text));
	strcpy(text, pText[File_index]->text(Line_index - i ).ascii());
	for( k = strlen(text)-1 ; k > -1  ; k--)
	{
	    if(text[k] == ' ' || text[k] == '	')
		;
	    else if(text[k] == '{')
		return false;
	    else if(text[k] == ';')
		return false;
	    else if(text[k] == ')')
		return true;
	}
    }
}

int Debuger_Form::Filter_For_Loop( char temp[1000] )// Filtering "For Loop"
{
    int flag_index = 0;
    for(int j = 0 ; j < strlen( temp) ; j++)
    {
  	switch( flag_index )
	{
	case 0:
	    if( ( temp[j] == ' ' ||  temp[j] == '	') && strncmp( temp + j +1, "for", 3) == 0)
	    {		
		for(int k = j + 4 ; k < strlen( temp) ; k++)
		{
			if(  temp[k] == ' ' ||  temp[k] == '	')
			{
			    ;
			}
			else if(  temp[k] == '(' )
			{
			    flag_index = 1;
			    j = k+1;
			    break;
			}
			else
			{
			    break;
			}
		    }
		}
	break;
              case 1:
	  if( temp[j] == ')')
	      return j;
	break;				
	}
    }
    return -1;
}

int Debuger_Form::Comment_Filter( int i )
{
    char CodeLine[1000];
    memset(&CodeLine, 0, sizeof(CodeLine));
    strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
    while( 1 )
    {
	for( i ; i < strlen(CodeLine) ; i++)
	{
	    if(CodeLine[i] == '*' && CodeLine[i+1] == '/') 
	    {
		return i;
	    }
	}
	memset(&CodeLine, 0, sizeof(CodeLine));
	strcpy(CodeLine, pText[File_index]->text(++Line_index).ascii());
	i = 0;
    }
}


void Debuger_Form::V_R_Table_SIGNAL()
{
    Cmd_Value_INFO_clicked();  
}

void Debuger_Form::Func_End_FSA()
{
    int midle_flag = 1;
    char CodeLine[1000];
    char Token[100];
    int Token_index = 0;
    QString snprintf_code;
    QString main_code;
    QString temp;
    memset(&CodeLine, 0, sizeof(CodeLine));
    memset(&Token, 0, sizeof(Token));
    
    while(midle_flag != 0)
    {
	memset(&CodeLine, 0, sizeof(CodeLine));
	
	if( pText[File_index]->paragraphs ()-1 == Line_index )
	    return;
	else
	    strcpy(CodeLine, pText[File_index]->text(++Line_index).ascii());
//	temp.sprintf("%d %d %d %s", midle_flag, pText[File_index]->paragraphs(), Line_index, CodeLine);
//	QMessageBox::question(this, temp, temp);
	for( int i = 0 ; i < strlen(CodeLine)+1 ; i++)
	{

	    if(CodeLine[i] == '/' && CodeLine[i+1] == '/')
	    {
		break;
	    }
	    else if(CodeLine[i] == '/' && CodeLine[i+1] == '*')
	    {
		i = Comment_Filter( i )+1;
		memset(&CodeLine, 0, sizeof(CodeLine));
		strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
	    }
	    else if( CodeLine[i] == ' ' || CodeLine[i] == '	' || CodeLine[i] == '(' || CodeLine[i] == ')' )
	    {
		if(strcmp( Token, "return") == 0 && main_flag == true)
		{
		    main_code.sprintf("BP(%d,  %d, %d, 2);",atoi(Make_Break_Code(File_index, Line_index).ascii()),fd[0], fd_p[1]);
		    pText[File_index]->insertAt(main_code+"End();", Line_index, i-6);
		}
		else if(strcmp( Token, "return") == 0)
		{
	//	    main_code.sprintf("BP(%d,  %d, %d, 5);",atoi(Make_Break_Code(File_index, Line_index).ascii()),fd[0], fd_p[1]);
	//	    pText[File_index]->insertAt(main_code+"End();", Line_index, i-6);
		    	    pText[File_index]->insertAt("End();", Line_index, i-6);
		}
		
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
	    }
	    else if(CodeLine[i] == ';') 
	    {
		
		if(strcmp( Token, "return") == 0 && main_flag == true)
		{
		    main_code.sprintf("BP(%d,  %d, %d, 2);",atoi(Make_Break_Code(File_index, Line_index).ascii()),fd[0], fd_p[1]);
		    pText[File_index]->insertAt(main_code+"End();", Line_index, i-6);
		}
		else if(strcmp( Token, "return") == 0)
		{
		    pText[File_index]->insertAt("End();", Line_index, i-6);
		}
		
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
	    }
	    else if(CodeLine[i] == '{')
	    {
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
		midle_flag++;
	    }
	    else if(CodeLine[i] == '}')
	    {
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
		midle_flag--;
	    }	    
	    else
	    {
		Token[Token_index] = CodeLine[i];
		Token_index++;
	    }
	}

//	QMessageBox::question(this, "while end", temp);
    }

}


void Debuger_Form::Value_Setting()
{
    VR_Click_flag = true;
    Value_Text->clear();
    QFile file;
    file.setName("/G_Studio/Debugger/Value_list.txt");
    if(!file.open(IO_ReadOnly))
    {
	QMessageBox::warning(this, "File (Value_list.txt) Open Error", "Can NOT open File (Value_list.txt)\nSo Load Empty File on this FileName");
	return ;
    }
	 QTextStream stream(&file);
	 Value_Text->setText(stream.read());
	 file.close();
}


bool Debuger_Form::Find_main_Func()
{
    char Token[100];
    char CodeLine[1000];
    int token_index = 0;
    bool comment_flag = true;
    bool flag = false;
    bool main_flag = false;
    memset(&Token, 0, sizeof(Token));
  
    for( int i = 0 ; i < 100 ; i++)
    {
	memset(&CodeLine, 0, sizeof(CodeLine));  
	strcpy(CodeLine, pText[File_index]->text(Line_index - i).ascii());
	memset(&Token, 0, sizeof(Token));
	for( int j = 0 ; j < strlen(CodeLine) ; j++)
	{
	    if(CodeLine[j] == '/' && CodeLine[j+1] == '/')
	    {
		break;		
	    }
	    else if(CodeLine[j] == '/' && CodeLine[j+1] == '*')
	    {
		comment_flag = false;
	    }
	    else if(CodeLine[j] == '*' && CodeLine[j+1] == '/')
	    {
		comment_flag = true;
	    }
	    else if(CodeLine[j] == '{')
	    {
		break;
	    }
	    else if( CodeLine[j] == ' ' || CodeLine[j] == '	' || CodeLine[j] == '(' )
	    {
		if(strcmp( Token, "main") == 0)
		{
		    main_flag = true;
		    break;
		}
		memset(&Token, 0, sizeof(Token));
		token_index = 0;
	    
	    }
	    else if(comment_flag)
	    {
		flag = true;
		Token[token_index] = CodeLine[j];
		token_index++;
	    }
	}
	if( flag )
	    return main_flag;
    }
    
}



void Debuger_Form::Table_text_changed()
{
        QMessageBox::question(this, "aaa", "aa");
//    QMessageBox::question(this, V_R_Table->key(), V_R_Table->key())
}


void Debuger_Form::Set_Variable_list()
{
    variable_list->clear();
    Value_Setting();
    QString Value_INFO[3];
    int array_byte;
    int Pix_index;
    int index = 0;
    int array_size;
    char buffer[100];
    char Value_code[300];
    char Send_message[300];
    QListViewItem *item;
    bool char_flag = false; // for Checking char array ------------>  %c OR %s
    bool array_flag = false;
    memset(&Send_message, 0, sizeof(Send_message));    
    for(int i = Value_Text->paragraphs() -1; i > -1 ; i--)
    {
	index = 0;
	memset(&Value_code, 0, sizeof(Value_code));
	memset(&buffer, 0, sizeof(buffer));
	strcpy(Value_code, Value_Text->text(i).ascii());
	array_flag = false;
////////////////////////////////////////////////////////////////////////
	if ( strncmp( Value_code, "Function Start", 14) == 0)
	    return ;
/////////////////////////////////////////////////////////////////////////
	memset(&Send_message, 0, sizeof(Send_message)); 
	for(int j = 0 ; j < strlen(Value_code) ; j++)
	{
	    if( Value_code[j] == '/' )
	    {
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		if( index == 0)
		{
		    strncpy(buffer, Value_code, j);
		    Value_INFO[0].sprintf("%s", buffer);
		    if( strcmp( buffer , "int") == 0)
		    {
			strcat(Send_message, "00000");
			Pix_index = 1;
			index = 1;
		    }	
		    else if( strcmp( buffer , "char") == 0)
		    {
			Pix_index = 2;
			strcat(Send_message, "00001");			
			index = 1;			
		    }
		    else if( strcmp( buffer , "short") == 0)
		    {
			Pix_index = 3;			
			strcat(Send_message, "00002");
			index = 1;			
		    }
		    else if( strcmp( buffer , "float") == 0)
		    {
			Pix_index = 4;			
			strcat(Send_message, "00003");
			index = 1;			
		    }
		    else if( strcmp( buffer , "double") == 0)
		    {
			Pix_index = 5;			
			strcat(Send_message, "00004");
			index = 1;			
		    }
		    else if( strcmp( buffer , "long") == 0)
		    {
			Pix_index = 6;			
			strcat(Send_message, "00006");
			index = 1;			
		    }
		    if( strcmp( buffer , "^int" ) == 0)
		    {
			Pix_index = 7;			
			strcat(Send_message, "00007");
			array_flag = true;
			array_byte = 4;
			index = 3;
		    }	
		    else if( strcmp( buffer , "^char" ) == 0)
		    {
			Pix_index = 8;			
			strcat(Send_message, "00014" );	
			array_byte = 1;
			array_flag = true;
			char_flag = true;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^short") == 0)
		    {
			Pix_index = 9;			
			strcat(Send_message, "00009");
			array_flag = true;			
			array_byte = 2;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^float") == 0)
		    {
			Pix_index = 10;			
			strcat(Send_message, "00010");
			array_flag = true;			
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^double") == 0)
		    {
			Pix_index = 11;			
			strcat(Send_message, "00011");
			array_flag = true;			
			array_byte = 8;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^long") == 0)
		    {
			Pix_index = 12;			
			strcat(Send_message, "00013");
			array_flag = true;			
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "*int") == 0)
		    {
			Pix_index = 13;			
			strcat(Send_message, "00015");
			index = 1;
		    }	
		    else if( strcmp( buffer , "*char") == 0)
		    {
			Pix_index = 14;			
			strcat(Send_message, "00016");			
			index = 1;			
		    }
		    else if( strcmp( buffer , "*short") == 0)
		    {
			Pix_index = 15;			
			strcat(Send_message, "00017");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*float") == 0)
		    {
			Pix_index = 16;			
			strcat(Send_message, "00018");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*double") == 0)
		    {
			Pix_index = 17;			
			strcat(Send_message, "00019");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*bool") == 0)
		    {
			Pix_index = 18;			
			strcat(Send_message, "00020");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*long") == 0)
		    {
			Pix_index = 19;			
			strcat(Send_message, "00021");
			index = 1;			
		    }
		    if( strcmp( buffer , "^*int" ) == 0)
		    {
			Pix_index = 20;			
			array_flag = true;			
			strcat(Send_message, "00022");
			array_byte = 4;
			index = 3;
		    }	
		    else if( strcmp( buffer , "^*char" ) == 0)
		    {
			Pix_index = 21;			
			array_flag = true;				
			strcat(Send_message, "00023" );	
			array_byte = 1;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*short") == 0)
		    {
			Pix_index = 22;			
			array_flag = true;				
			strcat(Send_message, "00024");
			array_byte = 2;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*float") == 0 )
		    {
			Pix_index = 23;			
			array_flag = true;	
			strcat(Send_message, "00025");
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*double") == 0 )
		    {
			Pix_index = 24;			
			array_flag = true;				
			strcat(Send_message, "00026");
			array_byte = 8;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*long") == 0 )
		    {
			Pix_index = 25;			
			array_flag = true;				
			strcat(Send_message, "00028");
			array_byte = 4;
			index = 3;			
		    }

		    memset(&buffer, 0, sizeof(buffer));

		}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
		else if( index == 1 )
		{
		    strncpy(buffer, Value_code + Value_INFO[0].length() + 1, j - (Value_INFO[0].length()+1));
		    Value_INFO[1].sprintf("%s", buffer);
		    memset(&buffer, 0, sizeof(buffer));
		    if( array_flag == true )//if array data
		    {
			index = 4;			
		    }
		    else
		    {
			index = 2;
		    }
		}
		else if( index == 2 )
		{
		    char recevie_message[100];
		    memset(&recevie_message, 0, sizeof(recevie_message));
		    int length;
		    length = Value_INFO[0].length() + Value_INFO[1].length();
    		    strncpy(buffer, Value_code + length + 2, j - (length+2));
		    Value_INFO[2].sprintf("%s", buffer);
		    strcat(Send_message, buffer);
		    write(fd[1], Send_message, strlen(Send_message));
		    read(fd_p[0], recevie_message, sizeof(recevie_message));
		    item = new QListViewItem(variable_list, Value_INFO[1], recevie_message);
		    send_ListItem(item ,Pix_index );
		    variable_list->insertItem(item);
		}
		else if( index == 3)
		{		    
		    QString temp1;
    		    strncpy(buffer, Value_code + Value_INFO[0].length() + 1, j - (Value_INFO[0].length()+1));
		    temp1.sprintf("%s/%s",Value_INFO[0].ascii(), buffer);
		    array_size = atoi(buffer);
		    Value_INFO[0].sprintf("%s", temp1.ascii());
		    memset(&buffer, 0, sizeof(buffer));
		    index = 1;
		}
		else if( index = 4 )
		{
    		    char recevie_message[100];
		    char send_temp[300];
		    QString size;
		    QString array_name1;
		    QString array_name2;
		    array_name1.sprintf("%s", Value_INFO[1].ascii());
		    memset(&recevie_message, 0, sizeof(recevie_message));
		    int length;
		    length = Value_INFO[0].length() + Value_INFO[1].length();
    		    strncpy(buffer, Value_code + length + 2, j - (length+2));
		    Value_INFO[2].sprintf("%s", buffer);
		    memset(&send_temp, 0, sizeof(send_temp));
		    strcpy(send_temp, Send_message);
		    size.sprintf("%s[%d]", Value_INFO[1].ascii(), array_size);//Set arrya_name & size
		    Value_INFO[1].sprintf("%s", size.ascii());

		    if( char_flag == true )
		    {
			strcat(Send_message, buffer);
			write(fd[1], Send_message, strlen(Send_message));
			read(fd_p[0], recevie_message, sizeof(recevie_message));			
			item = new QListViewItem(variable_list, Value_INFO[1], recevie_message);
			send_ListItem(item ,Pix_index );
			variable_list->insertItem(item);
			char_flag = false;
		    }
		    else
		    {
			item = new QListViewItem(variable_list, Value_INFO[1], recevie_message);
			send_ListItem(item ,Pix_index );
			variable_list->insertItem(item);
			for( int i = array_size-1 ; i > -1 ; i--)
			{
			    array_name2.sprintf("%s[%d]", array_name1.ascii(), i);
			    size.sprintf("%d/%s", i, buffer);
			    strcat(Send_message, size.ascii());
			    write(fd[1], Send_message, strlen(Send_message));
			    read(fd_p[0], recevie_message, sizeof(recevie_message));
			    item  = variable_list->findItem( Value_INFO[1], 0 , Qt::ExactMatch);
			    item->insertItem( new QListViewItem(item, array_name2, recevie_message));
			    memset(&Send_message, 0, sizeof(Send_message));
			    memset(&recevie_message, 0, sizeof(recevie_message));
			    strcpy(Send_message, send_temp);
			}
		    }
		}
	    }

	}

    }
}






void Debuger_Form::send_ListItem( QListViewItem * item , int index )
{
    if( index == 1)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Int.png" ) );
    else  if( index == 2)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Char.png" ) );
    else  if( index == 3)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Short.png" ) );
    else  if( index == 4)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Float.png" ) );
    else  if( index == 5)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Double.png" ) );
    else  if( index == 6)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Long.png" ) );
    else  if( index == 7)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Int.png" ) );
    else  if( index == 8)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Char.png" ) );
    else  if( index == 9)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Short.png" ) );
    else  if( index == 10)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Float.png" ) );
    else  if( index == 11)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Double.png" ) );
    else  if( index == 12)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Long.png" ) );
    else  if( index == 13)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Int_P.png" ) );
    else  if( index == 14)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Char_P.png" ) );
    else  if( index == 15)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Short_P.png" ) );
    else  if( index == 16)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Float_P.png" ) );
    else  if( index == 17)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Double_P.png" ) );
    else  if( index == 19)
	item->setPixmap( 0, QPixmap::fromMimeSource( "Long_P.png" ) );
    else  if( index == 20)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Int_P.png" ) );
    else  if( index == 21)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Char_P.png" ) );
    else  if( index == 22)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Short_P.png" ) );
    else  if( index == 23)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Float_P.png" ) );
    else  if( index == 24)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Double_P.png" ) );
    else  if( index == 25)
	item->setPixmap( 0, QPixmap::fromMimeSource( "array_Long_P.png" ) );

}


void Debuger_Form::Terminal_clicked()
{
    VR_Click_flag = false;
}


void Debuger_Form::Debuger_code_text_chaged()
{
    int Line, Col;
    QString LineCol;
    pText[Debuger_Tab->indexOf(Debuger_Tab->currentPage()) ]->getCursorPosition(&Line, &Col);
    LineCol.sprintf("( FileName : %s ) Line : %d , Col : %d", Debuger_Tab->tabLabel(Debuger_Tab->currentPage()).ascii(), Line + 1, Col + 1);
    L_Line_Col->setText(LineCol);
}



QString Debuger_Form::Gloval_value_FSA( QString Mod)
{
    int midle_flag = 1;
    bool struct_flag = false;
    bool string_comment_flag = false;
    char CodeLine[1000];
    char Token[100];
    int Token_index = 0;
    QString snprintf_code;
    memset(&CodeLine, 0, sizeof(CodeLine));
    memset(&Token, 0, sizeof(Token));
    if( pText[File_index]->paragraphs ()-1 == Line_index )
    {
	return "Null";
    }
    else if( Mod == "1" )
    {
	strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
    }
    else
    {
	strcpy(CodeLine, Mod.ascii());
    }
    
    memset(&Token, 0, sizeof(Token));
    for( int i = 0 ; i < strlen(CodeLine)+1 ; i++)
    {
	if( CodeLine[i] == '"')
	{
	    if( string_comment_flag == false)
		string_comment_flag = true;
	    else
		string_comment_flag = false;
	}
	if(CodeLine[i] == '/' && CodeLine[i+1] == '/' &&string_comment_flag == false)
	{
	    break;
	}
	else if(CodeLine[i] == '/' && CodeLine[i+1] == '*' && string_comment_flag == false)
	{
	    i = Comment_Filter( i )+1;
	    memset(&CodeLine, 0, sizeof(CodeLine));
	    strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
	}
	else if( (CodeLine[i] == ' ' || CodeLine[i] == '	') && string_comment_flag == false)
	{
	    if( struct_flag )
	    {
		
	    }
	    else if( strcmp( Token , "int") == 0 || strcmp( Token , "int*") == 0)
	    {
		snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		if( strcmp("break", snprintf_code.ascii()) == 0)
		    break;
		return snprintf_code;
	    }
	    else if( strcmp( Token , "char") == 0 || strcmp( Token , "char*") == 0)
	    { 		  
		snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		if( strcmp("break", snprintf_code.ascii()) == 0)
		    break;
		return snprintf_code;
	    }
	    else if( strcmp( Token , "short") == 0 || strcmp( Token , "short*") == 0)
	    {	    
		snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		if( strcmp("break", snprintf_code.ascii()) == 0)
		    break;
		return snprintf_code;
	    }
	    else if( strcmp( Token , "float") == 0 || strcmp( Token , "float*") == 0)
	    {
		snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		if( strcmp("break", snprintf_code.ascii()) == 0)
		    break;
		return snprintf_code;
	    }
	    else if( strcmp( Token , "double") == 0 || strcmp( Token , "double*") == 0)
	    {
		snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		if( strcmp("break", snprintf_code.ascii()) == 0)
		    break;
		return snprintf_code;
	    }
	    else if( strcmp( Token , "bool") == 0 )
	    {
		snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		if( strcmp("break", snprintf_code.ascii()) == 0)
		    break;
		return snprintf_code;
	    }
	    else if( strcmp( Token , "long") == 0 || strcmp( Token , "long*") == 0)
	    {
		snprintf_code = Make_Value_Code( CodeLine, Token, &i );
		if( strcmp("break", snprintf_code.ascii()) == 0)
		    break;
		return snprintf_code;
	    }
	    else if( strcmp( Token, "struct" ) == 0)
	    {
		struct_flag = true;
		memset(&Token, 0, sizeof(Token));
	    }
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    //Checking Token && inisialize of Token
	}
	else if( (CodeLine[i] == '(' || CodeLine[i] == ')' ) && string_comment_flag == false)
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	}
	else if((CodeLine[i] == ';' ||CodeLine[i] == ',' )&& string_comment_flag == false) 
	{
	    
	}
	else if(CodeLine[i] == '{'&& string_comment_flag == false)
	{
	    midle_flag++;
	}
	else if(CodeLine[i] == '}'&& string_comment_flag == false)
	{
	    if( struct_flag )
		struct_flag = false;
	    midle_flag--;
	}	    
	else
	{
	    if(string_comment_flag == false)
	    {
		Token[Token_index] = CodeLine[i];
		Token_index++;
	    }
	}
    }
    return "Null";
}


void Debuger_Form::Set_Gloval_Variable_list()
{
    if(Gloval_Value_Setting() == false)
	return;
    QString Value_INFO[3];
    int array_byte;
    int Pix_index;
    int index = 0;
    int array_size;
    char buffer[100];
    char Value_code[300];
    char Send_message[300];
    QListViewItem *item;

    bool char_flag = false; // for Checking char array ------------>  %c OR %s
    bool array_flag = false;
    memset(&Send_message, 0, sizeof(Send_message));
    item = new QListViewItem(variable_list,"***** Local  Value *****", "********************");
    variable_list->insertItem(item);
    for(int i = Gloval__Value_list->paragraphs() -1; i > -1 ; i--)
    {
	index = 0;
	memset(&Value_code, 0, sizeof(Value_code));
	memset(&buffer, 0, sizeof(buffer));
	strcpy(Value_code, Gloval__Value_list->text(i).ascii());

	array_flag = false;
////////////////////////////////////////////////////////////////////////
	if ( strncmp( Value_code, "Function Start", 14) == 0)
	    return ;
/////////////////////////////////////////////////////////////////////////
	memset(&Send_message, 0, sizeof(Send_message)); 

	for(int j = 0 ; j < strlen(Value_code) ; j++)
	{
	    if( Value_code[j] == '/' )
	    {
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		if( index == 0)
		{
		    strncpy(buffer, Value_code, j);
		    Value_INFO[0].sprintf("%s", buffer);
		    if( strcmp( buffer , "int") == 0)
		    {
			strcat(Send_message, "00000");
			Pix_index = 1;
			index = 1;
		    }	
		    else if( strcmp( buffer , "char") == 0)
		    {
			Pix_index = 2;
			strcat(Send_message, "00001");			
			index = 1;			
		    }
		    else if( strcmp( buffer , "short") == 0)
		    {
			Pix_index = 3;			
			strcat(Send_message, "00002");
			index = 1;			
		    }
		    else if( strcmp( buffer , "float") == 0)
		    {
			Pix_index = 4;			
			strcat(Send_message, "00003");
			index = 1;			
		    }
		    else if( strcmp( buffer , "double") == 0)
		    {
			Pix_index = 5;			
			strcat(Send_message, "00004");
			index = 1;			
		    }
		    else if( strcmp( buffer , "long") == 0)
		    {
			Pix_index = 6;			
			strcat(Send_message, "00006");
			index = 1;			
		    }
		    if( strcmp( buffer , "^int" ) == 0)
		    {
			Pix_index = 7;			
			strcat(Send_message, "00007");
			array_flag = true;
			array_byte = 4;
			index = 3;
		    }	
		    else if( strcmp( buffer , "^char" ) == 0)
		    {
			Pix_index = 8;			
			strcat(Send_message, "00014" );	
			array_byte = 1;
			array_flag = true;
			char_flag = true;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^short") == 0)
		    {
			Pix_index = 9;			
			strcat(Send_message, "00009");
			array_flag = true;			
			array_byte = 2;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^float") == 0)
		    {
			Pix_index = 10;			
			strcat(Send_message, "00010");
			array_flag = true;			
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^double") == 0)
		    {
			Pix_index = 11;			
			strcat(Send_message, "00011");
			array_flag = true;			
			array_byte = 8;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^long") == 0)
		    {
			Pix_index = 12;			
			strcat(Send_message, "00013");
			array_flag = true;			
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "*int") == 0)
		    {
			Pix_index = 13;			
			strcat(Send_message, "00015");
			index = 1;
		    }	
		    else if( strcmp( buffer , "*char") == 0)
		    {
			Pix_index = 14;			
			strcat(Send_message, "00016");			
			index = 1;			
		    }
		    else if( strcmp( buffer , "*short") == 0)
		    {
			Pix_index = 15;			
			strcat(Send_message, "00017");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*float") == 0)
		    {
			Pix_index = 16;			
			strcat(Send_message, "00018");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*double") == 0)
		    {
			Pix_index = 17;			
			strcat(Send_message, "00019");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*bool") == 0)
		    {
			Pix_index = 18;			
			strcat(Send_message, "00020");
			index = 1;			
		    }
		    else if( strcmp( buffer , "*long") == 0)
		    {
			Pix_index = 19;			
			strcat(Send_message, "00021");
			index = 1;			
		    }
		    if( strcmp( buffer , "^*int" ) == 0)
		    {
			Pix_index = 20;			
			array_flag = true;			
			strcat(Send_message, "00022");
			array_byte = 4;
			index = 3;
		    }	
		    else if( strcmp( buffer , "^*char" ) == 0)
		    {
			Pix_index = 21;			
			array_flag = true;				
			strcat(Send_message, "00023" );	
			array_byte = 1;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*short") == 0)
		    {
			Pix_index = 22;			
			array_flag = true;				
			strcat(Send_message, "00024");
			array_byte = 2;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*float") == 0 )
		    {
			Pix_index = 23;			
			array_flag = true;	
			strcat(Send_message, "00025");
			array_byte = 4;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*double") == 0 )
		    {
			Pix_index = 24;			
			array_flag = true;				
			strcat(Send_message, "00026");
			array_byte = 8;
			index = 3;			
		    }
		    else if( strcmp( buffer , "^*long") == 0 )
		    {
			Pix_index = 25;			
			array_flag = true;				
			strcat(Send_message, "00028");
			array_byte = 4;
			index = 3;			
		    }

		    memset(&buffer, 0, sizeof(buffer));

		}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
		else if( index == 1 )
		{
		    strncpy(buffer, Value_code + Value_INFO[0].length() + 1, j - (Value_INFO[0].length()+1));
		    Value_INFO[1].sprintf("%s", buffer);
		    memset(&buffer, 0, sizeof(buffer));
		    if( array_flag == true )//if array data
		    {
			index = 4;			
		    }
		    else
		    {
			index = 2;
		    }
		}
		else if( index == 2 )
		{
		    char recevie_message[100];
		    memset(&recevie_message, 0, sizeof(recevie_message));
		    int length;
		    length = Value_INFO[0].length() + Value_INFO[1].length();
    		    strncpy(buffer, Value_code + length + 2, j - (length+2));
		    Value_INFO[2].sprintf("%s", buffer);
		    strcat(Send_message, buffer);
		    write(fd[1], Send_message, strlen(Send_message));
		    read(fd_p[0], recevie_message, sizeof(recevie_message));
		    item = new QListViewItem(variable_list, Value_INFO[1], recevie_message);
		    send_ListItem(item ,Pix_index );
		    variable_list->insertItem(item);
		}
		else if( index == 3)
		{		    
		    QString temp1;
    		    strncpy(buffer, Value_code + Value_INFO[0].length() + 1, j - (Value_INFO[0].length()+1));
		    temp1.sprintf("%s/%s",Value_INFO[0].ascii(), buffer);
		    array_size = atoi(buffer);
		    Value_INFO[0].sprintf("%s", temp1.ascii());
		    memset(&buffer, 0, sizeof(buffer));
		    index = 1;
		}
		else if( index = 4 )
		{
    		    char recevie_message[100];
		    char send_temp[300];
		    QString size;
		    QString array_name1;
		    QString array_name2;
		    array_name1.sprintf("%s", Value_INFO[1].ascii());
		    memset(&recevie_message, 0, sizeof(recevie_message));
		    int length;
		    length = Value_INFO[0].length() + Value_INFO[1].length();
    		    strncpy(buffer, Value_code + length + 2, j - (length+2));
		    Value_INFO[2].sprintf("%s", buffer);
		    memset(&send_temp, 0, sizeof(send_temp));
		    strcpy(send_temp, Send_message);
		    size.sprintf("%s[%d]", Value_INFO[1].ascii(), array_size);//Set arrya_name & size
		    Value_INFO[1].sprintf("%s", size.ascii());

		    if( char_flag == true )
		    {
			strcat(Send_message, buffer);
			write(fd[1], Send_message, strlen(Send_message));
			read(fd_p[0], recevie_message, sizeof(recevie_message));			
			item = new QListViewItem(variable_list, Value_INFO[1], recevie_message);
			send_ListItem(item ,Pix_index );
			variable_list->insertItem(item);
			char_flag = false;
		    }
		    else
		    {
			item = new QListViewItem(variable_list, Value_INFO[1], recevie_message);
			send_ListItem(item ,Pix_index );
			variable_list->insertItem(item);
			for( int i = array_size-1 ; i > -1 ; i--)
			{
			    array_name2.sprintf("%s[%d]", array_name1.ascii(), i);
			    size.sprintf("%d/%s", i, buffer);
			    strcat(Send_message, size.ascii());
			    write(fd[1], Send_message, strlen(Send_message));
			    read(fd_p[0], recevie_message, sizeof(recevie_message));
			    item  = variable_list->findItem( Value_INFO[1], 0 , Qt::ExactMatch);
			    item->insertItem( new QListViewItem(item, array_name2, recevie_message));
			    memset(&Send_message, 0, sizeof(Send_message));
			    memset(&recevie_message, 0, sizeof(recevie_message));
			    strcpy(Send_message, send_temp);
			}
		    }
		}
	    }

	}

    }
    item = new QListViewItem(variable_list,"***** Gloval Value *****", "********************");
    variable_list->insertItem(item);

}


bool Debuger_Form::Gloval_Value_Setting()
{
    VR_Click_flag = true;
    Gloval__Value_list->clear();
    QFile file;
    QString filename;
    filename.sprintf("/G_Studio/Debugger/%d.txt", Debuger_Tab->currentPageIndex());
     file.setName(filename);
    if(!file.open(IO_ReadOnly))
    {
	return false;
    }
	 QTextStream stream(&file);
	 Gloval__Value_list->setText(stream.read());
	 file.close();
	 return true;
}


void Debuger_Form::V_R_Table_clicked()
{
    Value_Setting();
    Gloval_Value_Setting();
}






bool Debuger_Form::Find_Value_INFO( QTable * )
{

}


